<?php

Yii::import('application.modules.core_models.models._base.BaseModel');

/**
 * This is the model base class for the table "waiting_room_setting".
 * DO NOT MODIFY THIS FILE! It is automatically generated by giix.
 * If any changes are necessary, you must set or override the required
 * property or method in class "WaitingRoomSetting".
 *
 * Columns in table "waiting_room_setting" available as properties of the model,
 * followed by relations of table "waiting_room_setting" available as properties of the model.
 *
 * @property integer $id
 * @property integer $enabled
 * @property integer $account_id
 * @property integer $provider_id
 * @property string $name
 * @property string $friendly_url
 * @property string $logo_path
 * @property integer $added_by_account_id
 * @property string $date_added
 * @property integer $updated_by_account_id
 * @property string $date_updated
 * @property string $welcome_message
 * @property string $rate_review_title
 * @property string $email_template
 * @property string $sms_template
 * @property integer $send_Review_request
 * @property string $custom_url
 * @property integer $provider_practice_listing_id
 * @property integer $account_device_id
 * @property integer $patient_point_enabled
 *
 * @property WaitingRoomInvite[] $waitingRoomInvites
 * @property Account $account
 * @property Provider $provider
 */
abstract class BaseWaitingRoomSetting extends BaseModel
{

    public static function model($className = __CLASS__)
    {
        return parent::model($className);
    }

    public function tableName()
    {
        return 'waiting_room_setting';
    }

    public static function label($n = 1)
    {
        return Yii::t('app', 'WaitingRoomSetting|WaitingRoomSettings', $n);
    }

    public static function representingColumn()
    {
        return 'name';
    }

    public function rules()
    {
        return array(
            array('account_id, provider_id, name, friendly_url, added_by_account_id, date_added, welcome_message', 'required'),
            array('enabled, account_id, provider_id, added_by_account_id, updated_by_account_id, send_review_request,
                provider_practice_listing_id, account_device_id, patient_point_enabled', 'numerical', 'integerOnly' => true),
            array('friendly_url', 'length', 'max'=>50),
            array('name', 'length', 'max'=>80),
            array('logo_path', 'length', 'max'=>255),
            array('date_updated', 'safe'),
            array('enabled, updated_by_account_id, date_updated, email_template, sms_template, rate_review_title, custom_url',
                'default', 'setOnEmpty' => true, 'value' => null),
            array('id, enabled, account_id, provider_id, name, friendly_url, logo_path, added_by_account_id, date_added,
                updated_by_account_id, date_updated, welcome_message, send_review_request, provider_practice_listing_id,
                account_device_id, rate_review_title, custom_url, patient_point_enabled', 'safe', 'on'=>'search'),
        );
    }

    public function relations()
    {
        return array(
            'waitingRoomInvites' => array(self::HAS_MANY, 'WaitingRoomInvite', 'waiting_room_setting_id'),
            'account' => array(self::BELONGS_TO, 'Account', 'account_id'),
            'provider' => array(self::BELONGS_TO, 'Provider', 'provider_id'),
        );
    }

    public function pivotModels()
    {
        return array(
        );
    }

    public function attributeLabels()
    {
        return array(
            'id' => Yii::t('app', 'ID'),
            'enabled' => Yii::t('app', 'Enabled'),
            'account_id' => null,
            'provider_id' => null,
            'name' => Yii::t('app', 'Name'),
            'friendly_url' => Yii::t('app', 'Friendly Url'),
            'logo_path' => Yii::t('app', 'Logo Path'),
            'added_by_account_id' => Yii::t('app', 'Added By Account'),
            'date_added' => Yii::t('app', 'Date Added'),
            'updated_by_account_id' => Yii::t('app', 'Updated By Account'),
            'date_updated' => Yii::t('app', 'Date Updated'),
            'welcome_message' => Yii::t('app', 'Welcome Message'),
            'rate_review_title' => Yii::t('app', 'Rate Review Title'),
            'email_template' => Yii::t('app', 'Email Template'),
            'sms_template' => Yii::t('app', 'SMS Template'),
            'send_review_request' => Yii::t('app', 'Send Review Request'),
            'custom_url' => Yii::t('app', 'Custom URL'),
            'provider_practice_listing_id' => Yii::t('app', 'Provider Practice Listing ID'),
            'account_device_id' => Yii::t('app', 'Account Device ID'),
            'patient_point_enabled' => Yii::t('app', 'PatientPoint Enabled'),
            'waitingRoomInvites' => null,
            'account' => null,
            'provider' => null,
        );
    }

    public function search()
    {
        $criteria = new CDbCriteria;

        $criteria->compare('id', $this->id);
        $criteria->compare('enabled', $this->enabled);
        $criteria->compare('account_id', $this->account_id);
        if (!intval($this->provider_id) && is_string($this->provider_id) && strlen($this->provider_id) > 0) {
            $criteria->with[] = 'provider';
            $criteria->addSearchCondition("provider.friendly_url", $this->provider_id);
        } else {
            $criteria->compare('provider_id', $this->provider_id);
        }
        $criteria->compare('name', $this->name, true);
        $criteria->compare('friendly_url', $this->friendly_url, true);
        $criteria->compare('logo_path', $this->logo_path, true);
        $criteria->compare('added_by_account_id', $this->added_by_account_id);
        $criteria->compare('date_added', $this->date_added, true);
        $criteria->compare('updated_by_account_id', $this->updated_by_account_id);
        $criteria->compare('date_updated', $this->date_updated, true);
        $criteria->compare('welcome_message', $this->welcome_message, true);
        $criteria->compare('rate_review_title', $this->rate_review_title, true);
        $criteria->compare('email_template', $this->email_template, true);
        $criteria->compare('sms_template', $this->sms_template, true);
        $criteria->compare('send_review_request', $this->send_review_request, true);
        $criteria->compare('custom_url', $this->custom_url, true);
        $criteria->compare('provider_practice_listing_id', $this->provider_practice_listing_id, true);
        $criteria->compare('account_device_id', $this->account_device_id, true);
        $criteria->compare('patient_point_enabled', $this->patient_point_enabled, true);

        return new CActiveDataProvider($this, array(
            'criteria' => $criteria, 'pagination' => array('pageSize' => 100)
        ));
    }

}
